<script lang="ts" setup>
import { computed } from 'vue';
import { Chat, ArrowUp } from 'slippers-ui/icons';
import { useI18n } from 'vue-i18n';

const icons = {
  ArrowUp,
};

const { updateFreeTrialGlmContent } = useEditQueryParams();

interface NextStepsProps {
  header?: string;
  blurb?: string;
  button?: {
    text: string;
    config: {
      href: string;
      dataGaName: string;
      dataGaLocation: string;
      icon?: string;
    };
  };
  secondaryButton?: {
    text: string;
    config: {
      href: string;
      dataGaName: string;
      dataGaLocation: string;
    };
  };
  config?: {
    disableSecondaryButton?: boolean;
  };
}

const props = defineProps<NextStepsProps>();
const { locale } = useI18n();

const { data } = await useAsyncData('next-steps', () =>
  queryContent(`/shared/${locale.value.toLocaleLowerCase()}/next-steps`).findOne(),
);

if (!data) {
  throw new Error(`Error with NextSteps component content`);
}

const content = computed(() => ({
  header: props.header || data.value.header,
  blurb: props.blurb || data.value.blurb,
  button: props.button || data.value.button,
  secondaryButton: props.secondaryButton || data.value.secondaryButton,
}));

const buttonHref = computed(() => updateFreeTrialGlmContent(content.value.button?.config.href || ''));

const secondaryButtonHref = computed(() => updateFreeTrialGlmContent(content.value.secondaryButton?.config.href || ''));
</script>

<template>
  <section class="next-steps">
    <SlpContainer>
      <div class="next-steps__container">
        <div class="next-steps__header slp-mb-16">
          <SlpTypography variant="heading2-bold" tag="h2">
            {{ content.header }}
          </SlpTypography>
        </div>
        <SlpTypography variant="heading5" tag="div" class="description slp-mb-24">
          <div v-html="$md.render(content.blurb)" />
        </SlpTypography>
        <div class="buttons">
          <SlpButton
            variant="secondary"
            :href="buttonHref"
            :data-ga-name="content.button.config.dataGaName"
            class="main-button"
            :data-ga-location="content.button.config.dataGaLocation || 'next step'"
          >
            {{ content.button.text }}
            <SlpIcon
              v-if="content.button.config.icon"
              :icon="icons[content.button.config.icon]"
              size="16"
              class="slp-ml-8"
            />
          </SlpButton>
          <SlpButton
            v-if="content.secondaryButton && !config?.disableSecondaryButton"
            variant="primary"
            :href="secondaryButtonHref"
            :data-ga-name="content.secondaryButton?.config.dataGaName"
            class="secondary-button"
            :data-ga-location="content.secondaryButton?.config.dataGaLocation || 'next step'"
          >
            <SlpIcon :icon="Chat" size="24" class="slp-mr-8" />{{ content.secondaryButton?.text }}
          </SlpButton>
        </div>
      </div>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.next-steps {
  background: $color-surface-700;
  color: $color-primary-300;
  padding-bottom: $spacing-32;
  position: relative;
  z-index: 1;

  &__container {
    background: $color-surface-700;
    padding: $spacing-64 $spacing-24;
    display: flex;
    flex-direction: column;
    align-items: center;
    border-bottom: 1px solid var(--slp-color-surface-600, #45424d);
    @media (min-width: $breakpoint-sm) {
      padding: $spacing-96;
    }
    @media (min-width: $breakpoint-md) {
      max-width: 100%;
    }
    @media (max-width: $breakpoint-lg) {
      text-align: center;
    }
    .description {
      max-width: 650px;
      text-align: center;
    }
    .buttons {
      display: flex;
      flex-direction: row;
      gap: 24px;
      @media (max-width: $breakpoint-lg) {
        flex-direction: column;
        width: 100%;
      }
      .secondary-button {
        border-radius: 4px;
        border: 1px solid var(--slp-color-surface-50, #fff);
      }
      .main-button,
      .secondary-button {
        justify-content: center;
      }
    }
  }
  &__header {
    background: linear-gradient(89.95deg, #feb484 3.13%, #a686f2 66.86%, #592ac8 123.2%);
    -webkit-background-clip: text;
    -webkit-text-fill-color: transparent;
    h2 {
      line-height: 1.14;
    }
  }
}
</style>
